/*
 * lookup.h -- header of host lookup engine
 * Part of the tcpick project
 *
 * Author: Francesco Stablum <duskdruid @ despammed.com>
 *
 * Copyright (C) 2003, 2004  Francesco Stablum
 * Licensed under the GPL
 *
 */

/* 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at you option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111,
 * USA.
 */

#ifndef _LOOKUP_H
#define _LOOKUP_H

struct _l_node /* the node/leaf of the tree */
{
	/* tree stuff */
	struct _l_node * parent;
	struct _l_node * left;
	char left_h;
	struct _l_node * right;
	char right_h;

	/* data */
	char * name;
	struct in_addr ip;
};

char *lookup(struct in_addr ia);
struct _l_node *_l_alloc(struct in_addr, char *);
char *_l_get(struct in_addr);

#endif
